package org.hmn.jrsd.demo;

import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

import javax.sql.DataSource;

/*
 * 
 * Cree par Harry Karadimas a 9 sept. 08
 */
public class H2DataSource
implements DataSource
{
  boolean driverLoaded = false;
  PrintWriter logWriter;
  String user;
  String password;
  String url;
  int openedConnectionCount = 0;
  
  public Connection getConnection()
  throws SQLException 
  {
    return getConnection(user, password);
  }

  public Connection getConnection(String username, String password)
      throws SQLException 
  {
    if (!driverLoaded) {
      try {
        Class.forName("org.h2.Driver");
        driverLoaded = true;
      }
      catch (Exception ex) {
        throw new SQLException("Could not load H2 driver ("+ex+")");
      }
    }
    Connection cxn = DriverManager.getConnection(url, user, password);
    //opening of connection succeeded, increment count of opened connections
    openedConnectionCount++;
    return cxn;
  }

  public PrintWriter getLogWriter()
  throws SQLException 
  {
    if (logWriter == null) {
      logWriter = new PrintWriter(System.out);
    }
    return logWriter;
  }
  
  public int getLoginTimeout() throws SQLException {
    return 0;
  }

  public void setLogWriter(PrintWriter out)
  throws SQLException 
  {
    logWriter = out;
  }

  public void setLoginTimeout(int seconds) throws SQLException {
  }

  public String getPassword() {
    return password;
  }

  public void setPassword(String password) {
    this.password = password;
  }

  public String getUrl() {
    return url;
  }

  public void setUrl(String url) {
    this.url = url;
  }

  public String getUser() {
    return user;
  }

  public void setUser(String user) {
    this.user = user;
  }

  public int getOpenedConnectionCount() {
    return openedConnectionCount;
  }

  public boolean isWrapperFor(Class<?> iface) throws SQLException {
    return false;
  }

  public <T> T unwrap(Class<T> iface)
  throws SQLException
  {
    throw new SQLException("Not implemented");
  }

}
