package org.hmn.jrsd.demo;

import java.util.HashSet;

import javax.swing.JTextField;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;
import javax.swing.text.PlainDocument;

import org.hmn.jrsd.rt.ReflectionHelpers;

/*
 * 
 * Cree par Harry Karadimas a 22 sept. 08
 */
public class JavaBeanDataModels
{
  Object bean;
  HashSet<BeanPropertyModel> beanPropModels = 
    new HashSet<BeanPropertyModel>();
  JTextField tf;

  public Object getBean() {
    return bean;
  }

  public void setBean(Object bean) {
    this.bean = bean;
  }
  
  public Document getModelAsDocument(String property)
  {
    BeanPropDocument doc = new BeanPropDocument(this, property);
    beanPropModels.add(doc);
    return doc;
  }
  
  static class BeanPropDocument
  extends PlainDocument
  implements BeanPropertyModel
  {
    
    JavaBeanDataModels mdl;
    String propName;
    
    public BeanPropDocument(JavaBeanDataModels mdl, String propName) 
    {
      this.mdl = mdl;
      this.propName = propName;
      String str = "foo";
      try {
        insertString(0, str, null);
      }
      catch (BadLocationException ex) {
        throw new RuntimeException(ex);
      }
    }

    public JavaBeanDataModels getJavaBeanDataModels() { return mdl; }

    public String getPropertyName() { return propName; }
    
    public void notifyOfBeanChange()
    {
      int len = getLength();
      try {
        remove(0, len);
      }
      catch (BadLocationException ex) {
        throw new RuntimeException(ex);
      }
      //getListeners(listenerType)
    }
    
    public Object getPropValue()
    {
      Object bn = mdl.getBean();
      if (bn == null) return null;
      Object val = ReflectionHelpers.callGet(bn, propName);
      return val;
    }
    
  }//BeanPropDocument
  
}

