package org.hmn.jrsd.demo;

import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.util.ArrayList;
import java.util.List;

import javax.sql.DataSource;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.SwingUtilities;

import org.hmn.jrsd.demo.orm.CDS;
import org.hmn.jrsd.demo.orm.FRIENDS;

import simpleorm.dataset.SDataSet;
import simpleorm.sessionjdbc.SSessionJdbc;

/*
 * 
 * Cree par Harry Karadimas a 9 sept. 08
 */
@SuppressWarnings("serial")
public class LendingCdsFrame
extends JFrame
{
  private static final long serialVersionUID = 1L;
  private static final Boolean FALSE = Boolean.FALSE; //shortcut to lighten code
  private static final Boolean TRUE = Boolean.TRUE; //shortcut to lighten code

  LendingCds mainApp;
  
  JPanel buttons = new JPanel();
  Action actionNewCd = new AbstractAction("New CD") {
    public void actionPerformed(ActionEvent e) {
      doNewCd();      
    }
  };
  Action actionNewFriend = new AbstractAction("New Friend") {
    public void actionPerformed(ActionEvent e) {
      doNewFriend();      
    }
  };
  Action actionSelCdsGivenBack = new AbstractAction("Selected CDS given back") {
    public void actionPerformed(ActionEvent e) {
      doSelectedCdsGivenBack();
    };
  };
  Action actionLendCds = new AbstractAction("Lend CDS") {
    public void actionPerformed(ActionEvent e) {
      doLendSelectedCds();
    };
  };
  JButton btnNewCd = new JButton(actionNewCd);
  JButton btnNewFriend = new JButton(actionNewFriend);
  JButton btnSelCdsGivenBack = new JButton(actionSelCdsGivenBack);
  JButton btnLendCds = new JButton(actionLendCds);
  JTabbedPane tabs = new JTabbedPane();
  
  JPanel pnlCds = new JPanel();  
  JScrollPane spCds;
  JTable tableCds;
  JrsdRecordTableModel<CDS> tmCds;
  
  JPanel pnlFriends = new JPanel();  
  JScrollPane spFriends;
  JTable tableFriends;
  JavaBeansTableModel tmFriends;
  
  JMenuBar bar = new JMenuBar();
  JMenu menuFile = new JMenu("File");
  Action quitAction = new AbstractAction("Quit") {
    public void actionPerformed(java.awt.event.ActionEvent e) {
      doQuit();
    };    
  };
  JMenuItem miQuit = new JMenuItem(quitAction);
  
  JMenu menuCds = new JMenu("CDS");
  JMenuItem miNewCd = new JMenuItem(actionNewCd);
  JMenuItem miSelCdsGivenBack = new JMenuItem(actionSelCdsGivenBack);
  JMenuItem miLendCds = new JMenuItem(actionLendCds);
  
  JMenu menuFriends = new JMenu("Friends");
  JMenuItem miNewFriend = new JMenuItem(actionNewFriend);
  
  DataSource ds;
  SSessionJdbc session;

  private FriendUpdateListener ful;
  
  public LendingCdsFrame(LendingCds mainApp) {
    this();
    this.mainApp = mainApp;    
  }
  
  public LendingCdsFrame() {
    initGui();    
  }
  
  private void initGui()
  {
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    Container cp = getContentPane();
    //finish the initialization of a few objects
    actionSelCdsGivenBack.putValue(Action.SHORT_DESCRIPTION, "The CDS that are selected were given back.");
    //---construct and add button bar
    buttons.setLayout(new FlowLayout());
    buttons.add(btnNewCd);
    buttons.add(btnNewFriend);
    buttons.add(btnSelCdsGivenBack);
    buttons.add(btnLendCds);
    cp.add(buttons, BorderLayout.NORTH);
    //---construct and add tabbed pane
    pnlCds.setLayout(new BorderLayout());
    pnlFriends.setLayout(new BorderLayout());
    tabs.add(pnlCds, "Cds");
    tabs.add(pnlFriends, "Friends");
    cp.add(tabs, BorderLayout.CENTER);    
    //---construct menus, and menu bar
    menuFile.add(miQuit);
    menuCds.add(miNewCd);
    menuCds.add(miSelCdsGivenBack);
    menuCds.add(miLendCds);
    menuFriends.add(miNewFriend);
    bar.add(menuFile);    
    bar.add(menuCds);
    bar.add(menuFriends);
    setJMenuBar(bar);
  }
  
  public void doQuit() {
    dispose();
  }
  
  private void doNewCd() {
    SSessionJdbc session = getOrMakeSession("doNewCd");
    try {
      session.begin();
      CDS rec = session.createWithGeneratedKey(CDS.meta);
      rec.setLENDED_F(false); //if we don't do this, optimistic locking will be broken
      session.commit();
      session.close(); //we need to close because refreshCdTable() reopens
      refreshCdTable();
    }
    finally {
      session.close();
    }
  }

  private void doNewFriend()
  {
    SSessionJdbc session = getOrMakeSession("doNewFriend");
    try {
      session.begin();
      FRIENDS rec = session.createWithGeneratedKey(FRIENDS.meta);
      rec.setLAST_NAME("<Friend>"+rec.getFRIENDS_ID());
      session.flush();
      //from this record, we make a "Friend" object
      Friend f = rec.makeFriend();
      session.commitAndDetachDataSet();
      refreshFriendTable(session);
    }
    finally {
      session.close();
    }    
  }
  
  public void doSelectedCdsGivenBack()
  {
    int[] selRows = tableCds.getSelectedRows();
    SDataSet dset = null;
    for (int index:selRows) {
      CDS cd = tmCds.getRecord(index);
      cd.setFRIENDS_ID(null);
      cd.setLENDED_F(Boolean.FALSE);
      dset = cd.getDataSet();
    }//for
    if (dset == null) return;
    SSessionJdbc session = getOrMakeSession("doSelectedCdsGivenBack");
    try {
      session.begin(dset); //reattach data set
      session.commitAndDetachDataSet(); //flush modifications and detach again
      refreshCdTable();
    }
    finally {
      session.close();
    }
  }
  
  public void doLendSelectedCds()
  {    
    ChooseFriendDialog dlg = new ChooseFriendDialog(this, tmFriends);
    dlg.pack();
    dlg.setVisible(true);
    System.out.println("Selected friend : "+dlg.getSelectedFriend());
    //if (true) return;
    Friend selFriend = dlg.getSelectedFriend();
    if (selFriend == null) return;
    int[] selRows = tableCds.getSelectedRows();    
    SDataSet dset = null;
    //first look if some cds are already lended
    List<CDS> lendedCds = new ArrayList<CDS>();
    for (int index:selRows) {
      CDS cd = tmCds.getRecord(index);
      if (TRUE.equals(cd.getLENDED_F())) lendedCds.add(cd);      
    }
    if (!lendedCds.isEmpty()) {
      String msg = "The following CDs are already lended : ";
      for (CDS cd : lendedCds) {
        msg = msg + "\n" + cd.getNAME() + " (" + cd.getARTIST() + ")";
      }
      JOptionPane.showMessageDialog(this, msg);
      return;
    }
    for (int index:selRows) {
      CDS cd = tmCds.getRecord(index);
      cd.setFRIENDS_ID(selFriend.getFriendId());
      cd.setLENDED_F(Boolean.TRUE);
      dset = cd.getDataSet();
    }//for
    if (dset == null) return;
    SSessionJdbc session = getOrMakeSession("doSelectedCdsGivenBack");
    try {
      session.begin(dset); //reattach data set
      session.commitAndDetachDataSet(); //flush modifications and detach again
      refreshCdTable();
    }
    finally {
      session.close();
    }
  }
  
  
  public DataSource getDatasource() {
    return ds;
  }

  public void openSessionForSwing()
  throws Exception
  {
//    Runnable sessionOpener = new Runnable() {
//      public void run() {
//        session = SSessionJdbc.open(ds, "LendingCds");
//      }
//    };
//    SwingUtilities.invokeAndWait(sessionOpener);
  }
  
  public void setDatasource(DataSource datasource) {
    this.ds = datasource;
  }

  public void refreshCdList()
  {
    if (spCds != null) pnlCds.remove(spCds);
    SSessionJdbc session = getOrMakeSession("refreshCdList");
    try {
      //no begin() here, it's in the methods
      List<CDS> allCds = CDS.selectAllCds(session);
      tmCds = new JrsdRecordTableModel<CDS>(ds, CDS.meta, allCds);
      tmCds.setRecords(allCds);
      tmCds.add(new CdFriendTfh(CDS.FRIENDS_ID, tmCds, mainApp));
      tableCds = new JTable(tmCds);
      spCds = new JScrollPane(tableCds);    
      pnlCds.add(spCds, BorderLayout.CENTER);
      validate(); //re-layout things
    }
    finally {
      session.close();
    }
  }
  
  public void refreshCdTable()
  {    
    SSessionJdbc session = getOrMakeSession("refreshCdTable");
    try {
      //no session.begin() here, it's in CDS.selectAllCds
      List<CDS> allCds = CDS.selectAllCds(session);
      tmCds.setRecords(allCds);
    }
    finally {
      session.close();
    }
  }
  
  public void refreshFriendList()
  {
    SSessionJdbc session = getOrMakeSession("refreshFriendList");
    try {      
      if (spFriends != null) pnlFriends.remove(spFriends);
      List<Friend> allFriends = FRIENDS.selectAllFriends(session);
      tmFriends = new JavaBeansTableModel(allFriends, "FriendId");
      if (ful == null) ful = new FriendUpdateListener(ds);
      tmFriends.addTableModelListener(ful);
      tableFriends = new JTable(tmFriends);
      spFriends = new JScrollPane(tableFriends);    
      pnlFriends.add(spFriends, BorderLayout.CENTER);
      validate();     
    }
    finally {
      session.close();
    }
  }
  
  public void refreshFriendTable(SSessionJdbc session)
  {    
    List<Friend> allFriends = FRIENDS.selectAllFriends(session);
    tmFriends.setBeans(allFriends);
  }

  /**
   * Gets a new session with the given name. If a session already
   * exists in the thread, close it first.
   * @param newSessionName
   * @return
   */
  public SSessionJdbc getOrMakeSession(String newSessionName)
  {
    SSessionJdbc session = SSessionJdbc.getThreadLocalSession();
    if (session != null) session.close(); 
    session = SSessionJdbc.open(ds, "refreshCdTable");
    return session;
  }
  
}
