<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
                xmlns="http://www.liquibase.org/xml/ns/dbchangelog/1.9">
                
  <xsl:output method="xml" indent="yes"/>
  
  <xsl:template match="/">  
<xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="jrsd-tables">
<databaseChangeLog 
    xsi:schemaLocation="http://www.liquibase.org/xml/ns/dbchangelog/1.9 http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-1.9.xsd">
  <xsl:apply-templates/>
</databaseChangeLog>    
  </xsl:template>

  <xsl:template match="table-def">
  <changeSet author="?" id="?">
    <createTable tableName="{@name}">
      <xsl:apply-templates/>
    </createTable>
  </changeSet>
  </xsl:template>
  
  <xsl:template match="column-def">
  <column name="{@name}" type="{col-type/@equiv-sql-type}" remarks="{@comment}">
  </column>
  </xsl:template>
  
  <xsl:template match="primary-key-def">
      <xsl:apply-templates/>  
  </xsl:template>
  
</xsl:stylesheet>

<!-- 
<changeSet author="jsmith" id="1">
        <createTable tableName="departments"
                     remarks="The departments of this company. Does not include geographical divisions.">
            <column name="id" type="number(4,0)">
                <constraints nullable="false" primaryKey="true"
                             primaryKeyName="DPT_PK"/>
            </column>
            <column name="dname" type="varchar2(14)"
                    remarks="The official department name as registered on the internal website."/>
        </createTable>
        <addUniqueConstraint constraintName="departments_uk1"
                             columnNames="dname" tableName="departments"/>
        <createSequence sequenceName="departments_seq"/>
    </changeSet>
-->
