/**
 * 
 */
package org.hmn.jrsd.test;

import org.apache.log4j.Logger;
import org.hmn.jrsd.rt.SormUtils;

import simpleorm.sessionjdbc.SSessionJdbc;

/**
 * @author KARADIMAS
 */
public class ClassYNFlagTests
  extends OraJrsdTestCase
{
  static Logger lg = Logger.getLogger(FieldListTests.class);
  
  /**
   * @see junit.framework.TestCase#setUp()
   */
  protected void setUp()
  throws Exception 
  {
    super.setUp();
    beginConnection("setUp");
    if (SormUtils.tableExists("TEST_CHARYNFLAG")) {
      SormUtils.ddl("DROP TABLE TEST_CHARYNFLAG");
    }
    SormUtils.ddl("CREATE TABLE TEST_CHARYNFLAG (" +
        "  ID integer ," + 
        "  FLG char(1) ," +
        "  FLG2 char(1) ," +
        "  PRIMARY KEY (ID)" +
        ")");    
    SormUtils.ddl("DELETE FROM TEST_CHARYNFLAG");
    SormUtils.ddl("INSERT INTO TEST_CHARYNFLAG (ID,FLG) VALUES (1, 'Y')");
    SormUtils.ddl("INSERT INTO TEST_CHARYNFLAG (ID,FLG) VALUES (2, 'N')");
    SormUtils.ddl("INSERT INTO TEST_CHARYNFLAG (ID,FLG) VALUES (3, 'X')");
    SormUtils.ddl("INSERT INTO TEST_CHARYNFLAG (ID,FLG) VALUES (4, null)");
    endConnection();
  }
    
  public void testRead1()  
  {
    SSessionJdbc session = beginConnection("testRead1");
    TEST_CHARYNFLAG_gen rec =
      session.find(TEST_CHARYNFLAG_gen.meta, 1);    
    assertEquals("Value is not 'true'", Boolean.TRUE, rec.getFLG());
    endConnection();
  }
    
  public void testRead2()  
  {
    SSessionJdbc session = beginConnection("testRead2");
    TEST_CHARYNFLAG_gen rec = 
      session.find(TEST_CHARYNFLAG_gen.meta, 2);
    assertEquals("Value is not 'false'", Boolean.FALSE, rec.getFLG());
    endConnection();
  }
    
  public void testRead3()  
  {
    SSessionJdbc session = beginConnection("testRead3");
    TEST_CHARYNFLAG_gen rec = 
      session.find(TEST_CHARYNFLAG_gen.meta, 3);
    assertFalse("Value is not false", rec.getFLG());
    endConnection();
  }
    
  public void testRead4()  
  {
    SSessionJdbc session = beginConnection("testRead4");
    TEST_CHARYNFLAG_gen rec = 
      session.find(TEST_CHARYNFLAG_gen.meta, 4);
    assertNotNull("session.find(TEST_CHARYNFLAG_gen.meta, 4) returned null", rec);
    assertNull("rec.getFLG() is not null", rec.getFLG());
    endConnection();
  }
    
  
}
