package org.hmn.jrsd.test;

import java.io.FileInputStream;
import java.sql.Connection;
import java.sql.Timestamp;
import java.util.Calendar;
import java.util.Date;
import java.util.Properties;

import org.apache.log4j.Logger;
import org.hmn.jrsd.rt.SormUtils;

import simpleorm.sessionjdbc.SSessionJdbc;

import junit.framework.TestCase;
/*
 * 
 * Cree par Harry Karadimas a 19 sept. 2006
 */
/**
 * 
 * @author karadimas
 */
public class FieldListTests
extends OraJrsdTestCase
{  
  static Logger lg = Logger.getLogger(FieldListTests.class);
  
  /**
   * @see junit.framework.TestCase#setUp()
   */
  protected void setUp()
  throws Exception 
  {
    super.setUp();
    String tableName = A_TABLE_WITH_SPACES_gen.meta.getTableName();
    beginConnection("setUp");
    if (!SormUtils.tableExists(tableName)) {
      System.out.println("Creating table "+tableName);
      SormUtils.ddl("CREATE TABLE \""+tableName+"\" (" +
          "  NAME varchar(20) ," + 
          "  ADDRESS varchar(20)," + 
          "  \"HAIR LENGTH\" number(9,2) ," +
          "  PRIMARY KEY (NAME)" +
          ")");
    }
    SormUtils.ddl("DELETE FROM \""+tableName+"\"");
    String colList = A_TABLE_WITH_SPACES_gen.fields.getColumnList();
    SormUtils.ddl("INSERT INTO \""+tableName+"\" ("+colList+") " +
        "VALUES ('FOO', 'Penny Lane 3', 25.3)");
    SormUtils.ddl("INSERT INTO \""+tableName+"\" ("+colList+") " +
        "VALUES ('BAR', 'Abbey Road 2', 38)");
    endConnection();
  }
    
  public void testRead()
  throws Exception
  {
    SSessionJdbc session = beginConnection("testRead");
    A_TABLE_WITH_SPACES_gen rec =
      session.find(A_TABLE_WITH_SPACES_gen.meta, "FOO");
    //lg.info("Hair length of FOO is "+rec.getHAIR_LENGTH()+" cm.");
    assertEquals("Hair length is not 25.3", 25.3d, rec.getHAIR_LENGTH().doubleValue(), 1e-99d);
    endConnection();
  }
    
}
