package org.hmn.jrsd.test;

import java.io.File;
import java.io.FileInputStream;
import java.util.Properties;

import javax.sql.DataSource;

import junit.framework.TestCase;

import org.apache.log4j.Appender;
import org.apache.log4j.FileAppender;
import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.apache.log4j.TTCCLayout;
import org.h2.jdbcx.JdbcDataSource;
import org.hmn.jrsd.rt.SormUtils;

import simpleorm.sessionjdbc.SDriver;
import simpleorm.sessionjdbc.SSessionJdbc;

/*
 * 
 * Cree par Harry Karadimas a 9 oct. 08
 */
public class H2_TABLE_WITH_SPACESTests
extends TestCase
{
  static Properties cxnProps = null;
  static DataSource ds = null;
  
  static final public void connect()
  throws Exception
  {
    if (cxnProps == null) {
      cxnProps = new Properties();
      cxnProps.load(new FileInputStream("local/h2-cxn.properties"));
      String url = cxnProps.getProperty("url");
      org.hmn.jrsd.test.TestUtils.loadDriver(cxnProps);
      JdbcDataSource jds = new JdbcDataSource();
      jds.setURL(url);
      jds.setUser(cxnProps.getProperty("user"));
      jds.setPassword(cxnProps.getProperty("password"));
      ds = jds;
    }    
  }
  
  /**
   * @see junit.framework.TestCase#setUp()
   */
  protected void setUp()
  throws Exception 
  {
    //add an "A2T" file appender to record output of the tests
    Appender apndr = Logger.getRootLogger().getAppender("A2T");
    if (apndr == null) {
      String fn = "test"+File.separator+"internaltests.log";
      //open in overwrite mode, as is is just for tests.
      FileAppender newAppender = 
        new FileAppender(new TTCCLayout(), fn, false);            
      newAppender.setThreshold(Level.DEBUG);
      Logger.getRootLogger().addAppender(newAppender);
      //SLogLog4jBridge.useSLogLog4jBridge();
    }
    connect();
    beginConnection("Table verification");
    String table = H2_TABLE_WITH_SPACES.meta.getTableName();
    if (SormUtils.tableExists(table)) SormUtils.ddl("DROP TABLE \""+table+"\"");
    SSessionJdbc session = SSessionJdbc.getThreadLocalSession();
    SDriver sd = session.getDriver();
    String sqlCreate = sd.createTableSQL(H2_TABLE_WITH_SPACES.meta);
    SormUtils.ddl(sqlCreate);
    endConnection();
  }
  
  @Override
  protected void tearDown() 
  throws Exception 
  {
    SSessionJdbc session = SSessionJdbc.getThreadLocalSession();
    if (session != null) session.close();
  }
  
  SSessionJdbc beginConnection(String name)
  {
    SSessionJdbc session = SSessionJdbc.open(ds, name);    
    session.begin();    
    return session;
  }
  
  void endConnection()
  {
    SSessionJdbc session = SSessionJdbc.getThreadLocalSession();
    session.commit();    
    session.close();
  }

  public void testRecordCreation()
  throws Exception
  {
    SSessionJdbc session = beginConnection("testRecordCreation");
    H2_TABLE_WITH_SPACES rec = session.create(H2_TABLE_WITH_SPACES.meta, 1);
    rec.setString(H2_TABLE_WITH_SPACES.cSOME_NAME, "Some arbitrary string");
    endConnection();
  }
  
}
