package org.hmn.jrsd.test;

import java.sql.ResultSet;

import simpleorm.dataset.SFieldFlags;
import simpleorm.dataset.SFieldObject;
import simpleorm.dataset.SRecordMeta;

/**
 * Demonstrates usage of a custom type. Here this type scrambles strings
 * before they are written to the database, and unscrambles them when read
 * back.
 */
public class SFieldMyCustomType
extends SFieldObject
{
  private char shiftLetter(char c, int offset)
  {
    if ('a' <= c & c <= 'z') {
      char c2 = (char)(c + offset);
      if (c2 < 'a') c2 += ('z' - 'a');
      if (c2 > 'z') c2 -= ('z' - 'a');
      return c2;
    }
    if ('A' <= c & c <= 'Z') {
      char c2 = (char)(c + offset);
      if (c2 < 'A') c2 += ('Z' - 'A');
      if (c2 > 'Z') c2 -= ('Z' - 'A');
      return c2;
    }
    return c;
  }
  
  private String shiftLetters(String s, int offset)
  {
    StringBuffer sb = new StringBuffer();
    char[] ca = s.toCharArray();
    for (int i = 0; i < ca.length; i++) {
      sb.append(shiftLetter(ca[i], offset));
    }
    return sb.toString();
  }
  
  public SFieldMyCustomType(
      SRecordMeta meta, String columnName, SFieldFlags... pvals) 
  {
    super(meta, columnName, pvals);
  }
  
  @Override
  public Object writeFieldValue(Object value) {
    if (value == null) return null;
    return shiftLetters(value.toString(), 3);
  }
  
  @Override
  public Object queryFieldValue(ResultSet rs, int sqlIndex)
  throws Exception
  {
    String str = rs.getString(sqlIndex);
    if (rs.wasNull()) return null;
    return shiftLetters(str, -3);
  }
  
}
