package org.hmn.jrsd.test;

import java.util.List;

import org.apache.log4j.Logger;
import org.hmn.jrsd.rt.AndExpr;
import org.hmn.jrsd.rt.BinOpExpr;
import org.hmn.jrsd.rt.WhereHelper;

import simpleorm.dataset.SQuery;
import simpleorm.sessionjdbc.SSessionJdbc;

import junit.framework.TestCase;
/*
 * 
 * Cree par Harry Karadimas a 5 oct. 2006
 */
/**
 * 
 * @author karadimas
 */
public class SqlExprTests
extends OraJrsdTestCase
{
  static Logger lg = Logger.getLogger(SqlExprTests.class);
  
  /**
   * @see org.hmn.jrsd.test.OraJrsdTestCase#setUp()
   */
  protected void setUp()
  throws Exception
  {
    super.setUp();
    beginConnection("SqlExprTests.setUp");
    SIMPLE_TABLE_Init.init_SIMPLE_TABLE();
    endConnection();
  }
  
  public void testAndExpr() throws Exception
  {
    WhereHelper w = new WhereHelper(
        new AndExpr(
            new BinOpExpr("DESCR", "=", null),
            new BinOpExpr("ID", "=", "3")
            )
    );
    lg.info("query text :"+w.getText());
    SSessionJdbc session = beginConnection("testAndExpr");
    SQuery<TEST_SIMPLE_TABLE_gen> q = 
      new SQuery<TEST_SIMPLE_TABLE_gen>(TEST_SIMPLE_TABLE_gen.meta);
    q.rawPredicate(w.getText(), w.getParameterArray());
    List<TEST_SIMPLE_TABLE_gen> recs = session.query(q);
    for (TEST_SIMPLE_TABLE_gen rec:recs) {
      lg.info("Read record nr : "+rec.getID());      
    }
    endConnection();
  }
  
  public void testOrExpr()
  throws Exception
  {
    
  }
  
}
