group jrsdsql;

tabledef(d, generatecomments) ::= <<
$if(d.comment)$
/*$d.comment$*/
$endif$
$if(d.literalSql)$
  $d.literalSql$
$else$

CREATE TABLE $d.qinName$  
$endif$
  /* version $d.version$ */ ($!
    !$$d.columnDefinitions:coldef(it);separator=","$
$if(d.extraSql)$
$d.extraSql$
$endif$
)
$if(d.postSql)$
$d.postSql$
$else$
;
$endif$

$if(d.aeComment)$
  $d.aeComment:tablecomment()$$\n$
$endif$
$d.columnDefinitions:colcomment()$
>>

coldef(d) ::= <<
$if(d.comment)$

  $\ $ /*$d.comment$*/ 
$endif$ 
$if (d.literalSql)$
  $\ $$d.literalSql$
$else$
  $if(d.primaryKeyDecl)$
    $\ $ PRIMARY KEY ($!
      !$$d.primaryKeys;separator=","$$!
    !$)
  $else$
    $\ $ $d.qinName$ $(d.type.typeName)(d.type)$
  $endif$
$endif$
>>

integer(t) ::= "integer$t.la$"
int(t) ::= "integer$t.la$"
date(t) ::= "date$t.la$"
number(t) ::= <<
  number($t.precision$$if(t.scale)$, $t.scale$$endif$)
>>
char(t) ::= "char($t.precision$)"
varchar(t) ::= "varchar($t.precision$)"
primitive_double(t) ::= "double"
double(t) ::= "double"
bytes(t) ::= "raw$if(t.precision)$($t.precision$)$endif$"
blob(t) ::= "blob"
clob(t) ::= "clob"
primitive_long(t) ::= "long"
long(t) ::= "long"
primitive_booleanchar(t) ::= "char(1)"
booleanchar(t) ::= "char(1)"
primitive_booleanbit(t) ::= "bit"
booleanbit(t) ::= "bit"
timestamp(t) ::= "timestamp"
time(t) ::= "time"
other(t) ::= " /* $t.param1$ */"

tablecomment() ::= <<
$if(generatecomments)$
COMMENT ON TABLE $d.qinName$ IS '$it$'
;
$endif$
>>

colcomment() ::= <<
$if(generatecomments)$
$if(it.aeComment)$
COMMENT ON COLUMN $d.qinName$.$it.qinName$ IS '$it.aeComment$'
;

$endif$
$endif$
>>
