// $ANTLR 2.7.6 (2005-12-22): "jrsd.g" -> "JrsdParser.java"$

package org.hmn.jrsd;
import java.util.ArrayList;
import java.util.List;
import java.util.HashMap;
import java.util.HashSet;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;

public class JrsdParser extends antlr.LLkParser       implements JrsdParserTokenTypes
 {

  ArrayList lits = new ArrayList();
  ArrayList errs = new ArrayList();
  void lc() { 
    JrsdLexer lx = (JrsdLexer) getInputState().getInput().getInput();
    String lcs= lx.popLiteralChars();
    //System.out.println(lcs);
    lits.add(lcs);
  };
  List literals() { ArrayList lst = lits; lits = new ArrayList(); return lst; }
  public void reportError(RecognitionException ex) {
    errs.add(ex);
    super.reportError(ex);
  }


protected JrsdParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public JrsdParser(TokenBuffer tokenBuf) {
  this(tokenBuf,10);
}

protected JrsdParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public JrsdParser(TokenStream lexer) {
  this(lexer,10);
}

public JrsdParser(ParserSharedInputState state) {
  super(state,10);
  tokenNames = _tokenNames;
}

	public final JrsdSpec  jrsdspec() throws RecognitionException, TokenStreamException {
		JrsdSpec spec = new JrsdSpec();
		
		
		try {      // for error handling
			preamble(spec);
			imports(spec);
			globalsets(spec);
			tabledefs(spec);
			match(Token.EOF_TYPE);
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_0);
		}
		return spec;
	}
	
	public final void preamble(
		JrsdSpec spec
	) throws RecognitionException, TokenStreamException {
		
		Token  a = null;
		Token  b = null;
		
		try {      // for error handling
			match(LITERAL_jrsd);
			match(INTNR);
			{
			switch ( LA(1)) {
			case LITERAL_encoding:
			{
				match(LITERAL_encoding);
				match(ID);
				break;
			}
			case EOF:
			case SC:
			case LITERAL_database:
			case LITERAL_import:
			case LITERAL_columnlist:
			case LITERAL_field:
			case INCLUDEDCOMMENT:
			case LITERAL_table:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case SC:
			{
				match(SC);
				break;
			}
			case EOF:
			case LITERAL_database:
			case LITERAL_import:
			case LITERAL_columnlist:
			case LITERAL_field:
			case INCLUDEDCOMMENT:
			case LITERAL_table:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case LITERAL_database:
			{
				match(LITERAL_database);
				a = LT(1);
				match(STRING);
				{
				switch ( LA(1)) {
				case STRING:
				{
					b = LT(1);
					match(STRING);
					break;
				}
				case SC:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(SC);
				
				spec.setDatabaseType(a.getText()); 
				spec.setDatabaseSubtype( b == null ? "" : b.getText() ); 
				
				break;
			}
			case EOF:
			case LITERAL_import:
			case LITERAL_columnlist:
			case LITERAL_field:
			case INCLUDEDCOMMENT:
			case LITERAL_table:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_1);
		}
	}
	
	public final void imports(
		JrsdSpec spec
	) throws RecognitionException, TokenStreamException {
		
		Token  i = null;
		
		try {      // for error handling
			{
			_loop10:
			do {
				if ((LA(1)==LITERAL_import)) {
					match(LITERAL_import);
					i = LT(1);
					match(STRING);
					{
					switch ( LA(1)) {
					case SC:
					{
						match(SC);
						break;
					}
					case EOF:
					case LITERAL_import:
					case LITERAL_columnlist:
					case LITERAL_field:
					case INCLUDEDCOMMENT:
					case LITERAL_table:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					spec.addImport(i.getText());
				}
				else {
					break _loop10;
				}
				
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_2);
		}
	}
	
	public final void globalsets(
		JrsdSpec spec
	) throws RecognitionException, TokenStreamException {
		
		
		try {      // for error handling
			{
			_loop13:
			do {
				switch ( LA(1)) {
				case LITERAL_columnlist:
				{
					setdecl(spec);
					break;
				}
				case LITERAL_field:
				{
					fieldprefix(spec);
					break;
				}
				default:
				{
					break _loop13;
				}
				}
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_3);
		}
	}
	
	public final void tabledefs(
		JrsdSpec spec
	) throws RecognitionException, TokenStreamException {
		
		
		try {      // for error handling
			{
			_loop18:
			do {
				if ((LA(1)==INCLUDEDCOMMENT||LA(1)==LITERAL_table)) {
					tabledef(spec);
				}
				else {
					break _loop18;
				}
				
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_0);
		}
	}
	
	public final void setdecl(
		JrsdSpec spec
	) throws RecognitionException, TokenStreamException {
		
		Token  qn = null;
		Token  a = null;
		
		try {      // for error handling
			match(LITERAL_columnlist);
			qn = LT(1);
			match(STRING);
			match(LITERAL_as);
			a = LT(1);
			match(ID);
			match(SC);
			spec.addGlobalColumnList(a.getText(), qn.getText());
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_2);
		}
	}
	
	public final void fieldprefix(
		JrsdSpec spec
	) throws RecognitionException, TokenStreamException {
		
		Token  fp = null;
		
		try {      // for error handling
			match(LITERAL_field);
			match(LITERAL_prefix);
			fp = LT(1);
			match(STRING);
			match(SC);
			spec.setFieldPrefix(fp.getText());
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_2);
		}
	}
	
	public final void tabledef(
		JrsdSpec spec
	) throws RecognitionException, TokenStreamException {
		
		Token  c1 = null;
		Token  b = null;
		Token  lit = null;
		Token  extraSql = null;
		Token  postSql = null;
		List c;
		
		try {      // for error handling
			
			String a = "";
			TableDef tdef = new TableDef();
			spec.addTableDef(tdef);
			
			{
			switch ( LA(1)) {
			case INCLUDEDCOMMENT:
			{
				c1 = LT(1);
				match(INCLUDEDCOMMENT);
				break;
			}
			case LITERAL_table:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(LITERAL_table);
			a=torcname();
			match(LITERAL_version);
			b = LT(1);
			match(INTNR);
			{
			switch ( LA(1)) {
			case LT:
			{
				lit = LT(1);
				match(LT);
				break;
			}
			case COL:
			case LPAR:
			case DIRECTIVE:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			c=directives();
			{
			switch ( LA(1)) {
			case COL:
			{
				match(COL);
				mappingdecls(tdef);
				break;
			}
			case LPAR:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			
			tdef.setComment(c1);
			tdef.setName(a);
			tdef.setVersion(b);
			tdef.setLiteralSql(lit);
			tdef.addDirectives(c);
			
			match(LPAR);
			{
			_loop24:
			do {
				if ((_tokenSet_4.member(LA(1)))) {
					coldef(tdef);
				}
				else {
					break _loop24;
				}
				
			} while (true);
			}
			{
			switch ( LA(1)) {
			case LT:
			{
				extraSql = LT(1);
				match(LT);
				tdef.setExtraSql(extraSql);
				break;
			}
			case RPAR:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(RPAR);
			{
			switch ( LA(1)) {
			case LT:
			{
				postSql = LT(1);
				match(LT);
				tdef.setPostSql(postSql);
				break;
			}
			case SC:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(SC);
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_3);
		}
	}
	
	public final String  torcname() throws RecognitionException, TokenStreamException {
		String name = "";
		
		Token  a = null;
		Token  b = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case ID:
			{
				a = LT(1);
				match(ID);
				name = a.getText();
				break;
			}
			case STRING:
			{
				b = LT(1);
				match(STRING);
				name = b.getText();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_5);
		}
		return name;
	}
	
	public final List  directives() throws RecognitionException, TokenStreamException {
		List dl = new ArrayList();
		
		Token  d = null;
		
		try {      // for error handling
			{
			_loop63:
			do {
				if ((LA(1)==DIRECTIVE)) {
					d = LT(1);
					match(DIRECTIVE);
					dl.add(d.getText());
				}
				else {
					break _loop63;
				}
				
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_6);
		}
		return dl;
	}
	
	public final void mappingdecls(
		TableDef td
	) throws RecognitionException, TokenStreamException {
		
		Token  c1 = null;
		Token  c2 = null;
		MappingDecl md = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case INCLUDEDCOMMENT:
			{
				c1 = LT(1);
				match(INCLUDEDCOMMENT);
				break;
			}
			case LITERAL_simpleorm:
			case LITERAL_transport:
			case LITERAL_fieldset:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			md=mappingdecl();
			md.setComment(c1); td.addMappingDecl(md);
			{
			_loop33:
			do {
				if ((LA(1)==COM)) {
					match(COM);
					{
					switch ( LA(1)) {
					case INCLUDEDCOMMENT:
					{
						c2 = LT(1);
						match(INCLUDEDCOMMENT);
						break;
					}
					case LITERAL_simpleorm:
					case LITERAL_transport:
					case LITERAL_fieldset:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					md=mappingdecl();
					md.setComment(c2); td.addMappingDecl(md);
				}
				else {
					break _loop33;
				}
				
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_7);
		}
	}
	
	public final void coldef(
		TableDef td
	) throws RecognitionException, TokenStreamException {
		
		Token  ic = null;
		Token  la = null;
		Token  lb = null;
		ColumnTypeDef ct = null; ArrayList fds = null; String a = ""; List ds;
		
		try {      // for error handling
			ArrayList pks = null; ColumnDef cd = null;
			{
			switch ( LA(1)) {
			case INCLUDEDCOMMENT:
			{
				ic = LT(1);
				match(INCLUDEDCOMMENT);
				break;
			}
			case ID:
			case STRING:
			case LITERAL_primary:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case LITERAL_primary:
			{
				match(LITERAL_primary);
				match(LITERAL_key);
				match(LPAR);
				pks=idlist();
				match(RPAR);
				{
				switch ( LA(1)) {
				case LT:
				{
					la = LT(1);
					match(LT);
					break;
				}
				case SC:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(SC);
				cd = new ColumnDef(td, ic, pks, la); td.addColumnDef(cd);
				break;
			}
			case ID:
			case STRING:
			{
				{
				a=torcname();
				ct=sqltype();
				{
				switch ( LA(1)) {
				case LT:
				{
					lb = LT(1);
					match(LT);
					break;
				}
				case SC:
				case COL:
				case DIRECTIVE:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				ds=directives();
				
				cd = new ColumnDef(td, ic, a, ct, lb); td.addColumnDef(cd);
				cd.addDirectives(ds);
				
				{
				switch ( LA(1)) {
				case COL:
				{
					match(COL);
					fielddecls(cd);
					break;
				}
				case SC:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(SC);
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_8);
		}
	}
	
	public final MappingDecl  mappingdecl() throws RecognitionException, TokenStreamException {
		MappingDecl md = null;
		
		Token  cn = null;
		Token  ab = null;
		Token  xn = null;
		Token  i = null;
		Token  lc = null;
		Token  tn = null;
		Token  j = null;
		Token  fsn = null;
		Token  k = null;
		List flags = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_simpleorm:
			{
				match(LITERAL_simpleorm);
				cn = LT(1);
				match(STRING);
				{
				switch ( LA(1)) {
				case LITERAL_extends:
				{
					match(LITERAL_extends);
					{
					switch ( LA(1)) {
					case LITERAL_abstract:
					{
						ab = LT(1);
						match(LITERAL_abstract);
						break;
					}
					case STRING:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					xn = LT(1);
					match(STRING);
					break;
				}
				case LITERAL_as:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(LITERAL_as);
				i = LT(1);
				match(ID);
				flags=directives();
				{
				switch ( LA(1)) {
				case LT:
				{
					lc = LT(1);
					match(LT);
					break;
				}
				case LPAR:
				case COM:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				
				md = new MappingDecl("simpleorm", cn.getText(), i.getText()); 
				md.setSuperClass(xn == null ? null : xn.getText());
				md.setSuperClassAbstract(ab != null);
				md.setExtraCode(lc);
				md.setSormFlags(flags);
				
				break;
			}
			case LITERAL_transport:
			{
				match(LITERAL_transport);
				tn = LT(1);
				match(STRING);
				match(LITERAL_as);
				j = LT(1);
				match(ID);
				md = new MappingDecl("transport", tn.getText(), j.getText());
				break;
			}
			case LITERAL_fieldset:
			{
				match(LITERAL_fieldset);
				fsn = LT(1);
				match(STRING);
				match(LITERAL_as);
				k = LT(1);
				match(ID);
				md = new MappingDecl("fieldset", fsn.getText(), k.getText());
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_9);
		}
		return md;
	}
	
	public final ArrayList  idlist() throws RecognitionException, TokenStreamException {
		ArrayList ids = null;
		
		
		try {      // for error handling
			String a = ""; String b = "";
			a=torcname();
			ids = new ArrayList(); ids.add(a);
			{
			_loop70:
			do {
				if ((LA(1)==COM)) {
					match(COM);
					b=torcname();
					ids.add(b);
				}
				else {
					break _loop70;
				}
				
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_10);
		}
		return ids;
	}
	
	public final ColumnTypeDef  sqltype() throws RecognitionException, TokenStreamException {
		ColumnTypeDef td = null;
		
		Token  ac = null;
		Token  a = null;
		Token  aa = null;
		Token  ab = null;
		Token  bb = null;
		Token  b = null;
		Token  c = null;
		Token  d = null;
		Token  e = null;
		Token  f = null;
		Token  g = null;
		Token  h = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_char:
			{
				match(LITERAL_char);
				match(LPAR);
				ac = LT(1);
				match(INTNR);
				match(RPAR);
				td = new ColumnTypeDef("char", ac.getText(), null);
				break;
			}
			case LITERAL_varchar:
			{
				match(LITERAL_varchar);
				match(LPAR);
				a = LT(1);
				match(INTNR);
				match(RPAR);
				td = new ColumnTypeDef("varchar", a.getText(), null);
				break;
			}
			case LITERAL_bigdecimal:
			{
				match(LITERAL_bigdecimal);
				td = new ColumnTypeDef("bigdecimal", null, null);
				break;
			}
			case LITERAL_integer:
			{
				match(LITERAL_integer);
				td = new ColumnTypeDef("integer", null, null);
				break;
			}
			case LITERAL_int:
			{
				match(LITERAL_int);
				td = new ColumnTypeDef("int", null, null);
				break;
			}
			case LITERAL_primitive_long:
			{
				match(LITERAL_primitive_long);
				td = new ColumnTypeDef("primitive_long", null, null);
				break;
			}
			case LITERAL_long:
			{
				match(LITERAL_long);
				td = new ColumnTypeDef("long", null, null);
				break;
			}
			case LITERAL_primitive_double:
			{
				match(LITERAL_primitive_double);
				td = new ColumnTypeDef("primitive_double", null, null);
				break;
			}
			case LITERAL_double:
			{
				match(LITERAL_double);
				td = new ColumnTypeDef("double", null, null);
				break;
			}
			case LITERAL_date:
			{
				match(LITERAL_date);
				td = new ColumnTypeDef("date", null, null);
				break;
			}
			case LITERAL_timestamp:
			{
				match(LITERAL_timestamp);
				td = new ColumnTypeDef("timestamp", null, null);
				break;
			}
			case LITERAL_time:
			{
				match(LITERAL_time);
				td = new ColumnTypeDef("time", null, null);
				break;
			}
			case LITERAL_primitive_booleanbit:
			{
				match(LITERAL_primitive_booleanbit);
				td = new ColumnTypeDef("primitive_booleanbit", null, null);
				break;
			}
			case LITERAL_booleanbit:
			{
				match(LITERAL_booleanbit);
				td = new ColumnTypeDef("booleanbit", null, null);
				break;
			}
			case LITERAL_bytes:
			{
				match(LITERAL_bytes);
				{
				switch ( LA(1)) {
				case LPAR:
				{
					match(LPAR);
					bb = LT(1);
					match(INTNR);
					match(RPAR);
					break;
				}
				case SC:
				case LT:
				case COL:
				case DIRECTIVE:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				
				td = new ColumnTypeDef("bytes", (bb == null ? null : bb.getText()), null); 
				
				break;
			}
			case LITERAL_number:
			{
				match(LITERAL_number);
				{
				switch ( LA(1)) {
				case LPAR:
				{
					match(LPAR);
					b = LT(1);
					match(INTNR);
					{
					switch ( LA(1)) {
					case COM:
					{
						match(COM);
						c = LT(1);
						match(INTNR);
						break;
					}
					case RPAR:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					match(RPAR);
					break;
				}
				case SC:
				case LT:
				case COL:
				case DIRECTIVE:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				
				String ctxt = c == null ? null : c.getText();
				td = new ColumnTypeDef("number", b.getText(), ctxt); 
				
				break;
			}
			case LITERAL_other:
			{
				match(LITERAL_other);
				match(LPAR);
				d = LT(1);
				match(STRING);
				match(RPAR);
				td = new ColumnTypeDef("other", d.getText(), null);
				break;
			}
			case LITERAL_primitive_booleanchar:
			{
				match(LITERAL_primitive_booleanchar);
				match(LPAR);
				e = LT(1);
				match(STRING);
				match(COM);
				f = LT(1);
				match(STRING);
				match(RPAR);
				td = new ColumnTypeDef("primitive_booleanchar", e.getText(), f.getText());
				break;
			}
			case LITERAL_booleanchar:
			{
				match(LITERAL_booleanchar);
				match(LPAR);
				g = LT(1);
				match(STRING);
				match(COM);
				h = LT(1);
				match(STRING);
				match(RPAR);
				td = new ColumnTypeDef("booleanchar", g.getText(), h.getText());
				break;
			}
			default:
				if ((LA(1)==LITERAL_blob) && (LA(2)==LPAR)) {
					match(LITERAL_blob);
					match(LPAR);
					aa = LT(1);
					match(INTNR);
					match(RPAR);
					td = new ColumnTypeDef("blob", aa.getText(), null);
				}
				else if ((LA(1)==LITERAL_clob) && (LA(2)==LPAR)) {
					match(LITERAL_clob);
					match(LPAR);
					ab = LT(1);
					match(INTNR);
					match(RPAR);
					td = new ColumnTypeDef("clob", ab.getText(), null);
				}
				else if ((LA(1)==LITERAL_blob) && (_tokenSet_11.member(LA(2)))) {
					match(LITERAL_blob);
					td = new ColumnTypeDef("blob", ""+Integer.MAX_VALUE, null);
				}
				else if ((LA(1)==LITERAL_clob) && (_tokenSet_11.member(LA(2)))) {
					match(LITERAL_clob);
					td = new ColumnTypeDef("clob", ""+Integer.MAX_VALUE, null);
				}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_11);
		}
		return td;
	}
	
	public final void fielddecls(
		ColumnDef cd
	) throws RecognitionException, TokenStreamException {
		
		FieldDecl a = null;
		
		try {      // for error handling
			a=fielddecl(cd);
			cd.add(a);
			{
			_loop47:
			do {
				if ((LA(1)==COM)) {
					match(COM);
					a=fielddecl(cd);
					cd.add(a);
				}
				else {
					break _loop47;
				}
				
			} while (true);
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_12);
		}
	}
	
	public final FieldDecl  fielddecl(
		ColumnDef cd
	) throws RecognitionException, TokenStreamException {
		FieldDecl fd = new FieldDecl(cd);
		
		Token  a = null;
		Token  b = null;
		Token  b2 = null;
		Token  y = null;
		Token  c = null;
		Token  h = null;
		FieldDecl sf = null; List dl = null;
		
		try {      // for error handling
			{
			a = LT(1);
			match(ID);
			fd.setAlias(a);
			{
			if ((LA(1)==DOT) && (LA(2)==ID)) {
				match(DOT);
				b = LT(1);
				match(ID);
				fd.setFieldName(b);
			}
			else if ((LA(1)==DOT) && (LA(2)==STRING)) {
				match(DOT);
				b2 = LT(1);
				match(STRING);
				fd.setFieldName(b2);
			}
			else if ((_tokenSet_13.member(LA(1)))) {
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
			}
			{
			switch ( LA(1)) {
			case LPAR:
			{
				match(LPAR);
				sf=subfield(cd);
				fd.addSubfield(sf);
				{
				_loop53:
				do {
					if ((LA(1)==COM)) {
						match(COM);
						sf=subfield(cd);
						fd.addSubfield(sf);
					}
					else {
						break _loop53;
					}
					
				} while (true);
				}
				match(RPAR);
				break;
			}
			case ID:
			case SC:
			case COM:
			case LITERAL_int:
			case LITERAL_integer:
			case LITERAL_long:
			case LITERAL_primitive_long:
			case LITERAL_double:
			case LITERAL_primitive_double:
			case LITERAL_boolean:
			case LITERAL_primitive_boolean:
			case LITERAL_date:
			case LITERAL_bigdecimal:
			case LITERAL_blob:
			case LITERAL_ref:
			case DIRECTIVE:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case ID:
			case LITERAL_int:
			case LITERAL_integer:
			case LITERAL_long:
			case LITERAL_primitive_long:
			case LITERAL_double:
			case LITERAL_primitive_double:
			case LITERAL_boolean:
			case LITERAL_primitive_boolean:
			case LITERAL_date:
			case LITERAL_bigdecimal:
			case LITERAL_blob:
			case LITERAL_ref:
			{
				{
				switch ( LA(1)) {
				case LITERAL_int:
				{
					match(LITERAL_int);
					fd.setExplicitSFieldTypeName("int");
					break;
				}
				case LITERAL_integer:
				{
					match(LITERAL_integer);
					fd.setExplicitSFieldTypeName("Integer");
					break;
				}
				case LITERAL_long:
				{
					match(LITERAL_long);
					fd.setExplicitSFieldTypeName("Long");
					break;
				}
				case LITERAL_primitive_long:
				{
					match(LITERAL_primitive_long);
					fd.setExplicitSFieldTypeName("long");
					break;
				}
				case LITERAL_double:
				{
					match(LITERAL_double);
					fd.setExplicitSFieldTypeName("Double");
					break;
				}
				case LITERAL_primitive_double:
				{
					match(LITERAL_primitive_double);
					fd.setExplicitSFieldTypeName("double");
					break;
				}
				case LITERAL_boolean:
				{
					match(LITERAL_boolean);
					fd.setExplicitSFieldTypeName("Boolean");
					break;
				}
				case LITERAL_primitive_boolean:
				{
					match(LITERAL_primitive_boolean);
					fd.setExplicitSFieldTypeName("boolean");
					break;
				}
				case LITERAL_date:
				{
					match(LITERAL_date);
					fd.setExplicitSFieldTypeName("Date");
					break;
				}
				case LITERAL_bigdecimal:
				{
					match(LITERAL_bigdecimal);
					fd.setExplicitSFieldTypeName("BigDecimal");
					break;
				}
				case LITERAL_blob:
				{
					match(LITERAL_blob);
					fd.setExplicitSFieldTypeName("Blob");
					break;
				}
				case LITERAL_ref:
				{
					match(LITERAL_ref);
					y = LT(1);
					match(ID);
					fd.setExplicitSFieldTypeName("REF#"+y.getText());
					break;
				}
				case ID:
				{
					c = LT(1);
					match(ID);
					fd.setExplicitSFieldTypeName(c);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				{
				switch ( LA(1)) {
				case DBLCOL:
				{
					match(DBLCOL);
					{
					switch ( LA(1)) {
					case LITERAL_int:
					{
						match(LITERAL_int);
						fd.setSormBaseType("int");
						break;
					}
					case LITERAL_integer:
					{
						match(LITERAL_integer);
						fd.setSormBaseType("Integer");
						break;
					}
					case LITERAL_primitive_long:
					{
						match(LITERAL_primitive_long);
						fd.setSormBaseType("long");
						break;
					}
					case LITERAL_long:
					{
						match(LITERAL_long);
						fd.setSormBaseType("Long");
						break;
					}
					case LITERAL_primitive_double:
					{
						match(LITERAL_primitive_double);
						fd.setSormBaseType("double");
						break;
					}
					case LITERAL_double:
					{
						match(LITERAL_double);
						fd.setSormBaseType("Double");
						break;
					}
					case LITERAL_primitive_boolean:
					{
						match(LITERAL_primitive_boolean);
						fd.setSormBaseType("boolean");
						break;
					}
					case LITERAL_boolean:
					{
						match(LITERAL_boolean);
						fd.setSormBaseType("Boolean");
						break;
					}
					case LITERAL_date:
					{
						match(LITERAL_date);
						fd.setSormBaseType("Date");
						break;
					}
					case LITERAL_bigdecimal:
					{
						match(LITERAL_bigdecimal);
						fd.setSormBaseType("BigDecimal");
						break;
					}
					case LITERAL_bytes:
					{
						match(LITERAL_bytes);
						fd.setSormBaseType("byte[]");
						break;
					}
					case ID:
					{
						h = LT(1);
						match(ID);
						fd.setSormBaseType(h.getText());
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					break;
				}
				case SC:
				case COM:
				case DIRECTIVE:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				break;
			}
			case SC:
			case COM:
			case DIRECTIVE:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			dl=directives();
			fd.addDirectives(dl);
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_14);
		}
		return fd;
	}
	
	public final FieldDecl  subfield(
		ColumnDef cd
	) throws RecognitionException, TokenStreamException {
		FieldDecl fd = new FieldDecl(cd);
		
		Token  a = null;
		Token  b = null;
		Token  c = null;
		Token  c2 = null;
		
		try {      // for error handling
			a = LT(1);
			match(ID);
			fd.setAlias(a);
			{
			switch ( LA(1)) {
			case DOT:
			{
				match(DOT);
				{
				switch ( LA(1)) {
				case ID:
				{
					b = LT(1);
					match(ID);
					fd.setFieldName(b);
					break;
				}
				case INTNR:
				{
					c = LT(1);
					match(INTNR);
					fd.setFieldName(c);
					break;
				}
				case STRING:
				{
					c2 = LT(1);
					match(STRING);
					fd.setFieldName(c2);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				break;
			}
			case RPAR:
			case COM:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			recover(ex,_tokenSet_15);
		}
		return fd;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"jrsd\"",
		"INTNR",
		"\"encoding\"",
		"ID",
		"SC",
		"\"database\"",
		"STRING",
		"\"import\"",
		"\"columnlist\"",
		"\"as\"",
		"\"field\"",
		"\"prefix\"",
		"INCLUDEDCOMMENT",
		"\"table\"",
		"\"version\"",
		"LT",
		"COL",
		"LPAR",
		"RPAR",
		"COM",
		"\"simpleorm\"",
		"\"extends\"",
		"\"abstract\"",
		"\"transport\"",
		"\"fieldset\"",
		"\"primary\"",
		"\"key\"",
		"DOT",
		"\"int\"",
		"\"integer\"",
		"\"long\"",
		"\"primitive_long\"",
		"\"double\"",
		"\"primitive_double\"",
		"\"boolean\"",
		"\"primitive_boolean\"",
		"\"date\"",
		"\"bigdecimal\"",
		"\"blob\"",
		"\"ref\"",
		"DBLCOL",
		"\"bytes\"",
		"DIRECTIVE",
		"\"char\"",
		"\"varchar\"",
		"\"timestamp\"",
		"\"time\"",
		"\"clob\"",
		"\"primitive_booleanbit\"",
		"\"booleanbit\"",
		"\"number\"",
		"\"other\"",
		"\"primitive_booleanchar\"",
		"\"booleanchar\"",
		"WS",
		"CR",
		"LF",
		"IGNOREDCOMMENT",
		"ESCAPE"
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 2L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { 219138L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { 217090L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	private static final long[] mk_tokenSet_3() {
		long[] data = { 196610L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
	private static final long[] mk_tokenSet_4() {
		long[] data = { 536937600L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_4 = new BitSet(mk_tokenSet_4());
	private static final long[] mk_tokenSet_5() {
		long[] data = { 288132790212624384L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_5 = new BitSet(mk_tokenSet_5());
	private static final long[] mk_tokenSet_6() {
		long[] data = { 12058880L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_6 = new BitSet(mk_tokenSet_6());
	private static final long[] mk_tokenSet_7() {
		long[] data = { 2097152L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_7 = new BitSet(mk_tokenSet_7());
	private static final long[] mk_tokenSet_8() {
		long[] data = { 541656192L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_8 = new BitSet(mk_tokenSet_8());
	private static final long[] mk_tokenSet_9() {
		long[] data = { 10485760L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_9 = new BitSet(mk_tokenSet_9());
	private static final long[] mk_tokenSet_10() {
		long[] data = { 4194304L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_10 = new BitSet(mk_tokenSet_10());
	private static final long[] mk_tokenSet_11() {
		long[] data = { 70368745750784L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_11 = new BitSet(mk_tokenSet_11());
	private static final long[] mk_tokenSet_12() {
		long[] data = { 256L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_12 = new BitSet(mk_tokenSet_12());
	private static final long[] mk_tokenSet_13() {
		long[] data = { 87956645740928L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_13 = new BitSet(mk_tokenSet_13());
	private static final long[] mk_tokenSet_14() {
		long[] data = { 8388864L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_14 = new BitSet(mk_tokenSet_14());
	private static final long[] mk_tokenSet_15() {
		long[] data = { 12582912L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_15 = new BitSet(mk_tokenSet_15());
	
	}
