package org.hmn.jrsd;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/*
 * 
 * Cree par Harry Karadimas a 8 aot 2006
 */
/**
 * Used to associate the simpleorm fields with the transport object's fields.
 * @author karadimas
 */
public class MappedFieldsSet
{
  MappingDecl mapping;
  ArrayList<FieldDecl> fields = new ArrayList<FieldDecl>();
  
  public void addField(FieldDecl fd) {
    if (!fields.contains(fd)) fields.add(fd);
  }
  
  /**
   * Get fields in the order they were declared.
   * @return
   */
  public List<FieldDecl> getFields() 
  {
    return fields;
  }
  
  /**
   * @return A copy of the field declaration list, sorted in ascending order
   */
  public List<FieldDecl> getSortedFields() 
  {    
    ArrayList<FieldDecl> sortedList = new ArrayList<FieldDecl>(fields);
    Collections.sort(sortedList);
    return sortedList;
  }
  
  public MappingDecl getMapping()
  {
    return mapping;
  }
  
  public void setMapping(MappingDecl mapping)
  {
    this.mapping = mapping;
  }
  
}
