package org.hmn.jrsd;


/*
 * 
 * Cree par Harry Karadimas a 3 aot 2006
 */
/**
 * Composite name, separated by dots, with specialized methods to facilitate
 * manipulation.
 * @author karadimas
 */
public class QualifiedName
{
  String qn;  
  
  /**
   * 
   */
  public QualifiedName(String qn)
  {
    if (qn == null) throw new NullPointerException("qn est null");
    this.qn = qn;
  }
  
  public String getFirstElement()
  {
    int ix = qn.indexOf('.');
    if (ix < 0) return qn;
    return qn.substring(0, ix);
  }
  
  public String getWithoutFirstElement()
  {
    int ix = qn.indexOf('.');
    if (ix < 0) return "";
    return qn.substring(ix+1);
  }
  
  public String getLastElement()
  {
    int ix = qn.lastIndexOf('.');
    if (ix < 0) return qn;
    return qn.substring(0, ix+1);
  }
  
  public String getWithoutLastElement()
  {
    int ix = qn.indexOf('.');
    if (ix < 0) return "";
    return qn.substring(0, ix);
  }
  
  public boolean isSingle() { return qn.indexOf('.') < 0; }
  
  public int getElementCount()
  {
    int ec = 1;
    char[] ca = qn.toCharArray();
    for (int i = 0; i < ca.length; i++) {
      if (ca[i] == '.') ec++;
    }
    return ec;
  }
  
}
