package org.hmn.jrsd.rt;

/**
 * A node representing an "AND" sql expression 
 * @author karadimas
 */
public class AndExpr
extends ListExpr
{
  
  public AndExpr()
  {
    super("and");
  }
  
  public AndExpr(SqlExpr e)
  {
    super("and");
    add(e);
  }
  
  public AndExpr(SqlExpr e1, SqlExpr e2)
  {
    super("and");
    add(e1);
    add(e2);
  }
  
  /**
   * for each pkName, add a clause pkName = pkVal
   * @param pkNames
   * @param pkVal
   */
  public void addAllEqClauses(String[] pkNames, Object[] pkVals)
  {
    for (int i = 0; i < pkNames.length; i++) {
      String pkName = pkNames[i];
      Object pkVal = pkVals[i];
      BinOpExpr expr = new BinOpExpr(pkName, "=", pkVal);
      add(expr);
    }//for
  }
}
