package org.hmn.jrsd.rt;

/**
 * Fully qualified parameter; use this one to specify a particular sql
 * type when using the PreparedStatement (this has no effect on a 
 * SPreparedStatement). Used by {@link WhereHelper} to call setNull with
 * a specific type other than VARCHAR (sometimes avoids errors with picky
 * jdbc drivers).
 */
public class FqParameter
{
  private Object value;
  private int type;
 
  public FqParameter(Object value, int type) {
    this.value = value;
    this.type = type;
  }
  
  public Object getValue() {
    return value;
  }
  public void setValue(Object value) {
    this.value = value;
  }
  public int getType() {
    return type;
  }
  public void setType(int type) {
    this.type = type;
  }
}
