package org.hmn.jrsd.rt.dbops;

import java.util.HashMap;

/*
 * 
 * Cree par Harry Karadimas a 1 avr. 08
 */
/**
 * Ancestor of all "database operations". Each operation can have parameters,
 * and the operations are executed later, using 
 * {@link DbOps#executeOperations()} , inside a transaction. The result can
 * be retrieved, after the transaction has finished. 
 */
abstract public class DbOperation
{
  public static final int UPDATE_OP = 1;
  public static final int OBJECT_OP = 2;
  public static final int LIST_OP = 3;
  
  private HashMap<String,Object> params = new HashMap<String, Object>();
  
  abstract public int getOpType();
  
  public void addParam(String name, Object value) { params.put(name, value); }
  
  public Object getParam(String name) { return params.get(name); }
  
  public String getStringParam(String name) { 
    return (String) params.get(name); 
  }

}
