package org.hmn.jrsd.rt.dbops;

import java.sql.SQLException;

import org.hmn.jrsd.rt.ReflectionHelpers;

import simpleorm.sessionjdbc.SSessionJdbc;
import simpleorm.utils.SException;
import simpleorm.dataset.SRecordInstance;
import simpleorm.dataset.SRecordMeta;

/*
 * 
 * Cree par Harry Karadimas a 2 mai 08
 */
/**
 * Operation that creates a new record, using the declared generator, and
 * then copies the fields into the given transport object.
 */
public class DbRecordCreateOperation
extends DbUpdateOperation
{
  SRecordMeta<?> meta;
  Object transportObject;
  
  public DbRecordCreateOperation(SRecordMeta<?> meta, Object transportObject) {
    this.meta = meta;
    this.transportObject = transportObject;
  }
  
  public int execute()
  throws SQLException
  {
    SSessionJdbc session = SSessionJdbc.getThreadLocalSession();    
    SRecordInstance rec = session.createWithGeneratedKey(meta);
    try {
      ReflectionHelpers.callVoid("writeTo", rec, transportObject);
      return 1;
    }
    catch(Exception e) {
      throw new SException.Data(e);
    }
  }

}
