package org.hmn.jrsd.rt.dbops;

import java.sql.SQLException;

import org.hmn.jrsd.rt.ReflectionHelpers;

import simpleorm.sessionjdbc.SSessionJdbc;
import simpleorm.utils.SException;
import simpleorm.dataset.SRecordInstance;
import simpleorm.dataset.SRecordMeta;

/*
 * 
 * Cree par Harry Karadimas a 5 mai 08
 */
/**
 * Save the record, by transferring the values from the transport object to
 * the record itself; let simpleorm decide if insert or update should be
 * used. Note that execute() always returns 1 here; it is only at commit
 * time that a problem will eventually occur. Note that no key generation
 * happens here.
 */
public class DbRecordSaveOperation
extends DbUpdateOperation
{
  SRecordMeta<?> meta;
  Object keys;
  Object transportObject;
  long sqy_bitSet;
  
  public DbRecordSaveOperation(
      SRecordMeta<?> meta, Object keys, Object transportObject)
  {
    this(meta, keys, transportObject, 0L);
  }
  
  public DbRecordSaveOperation(
      SRecordMeta<?> meta, Object keys, Object transportObject, long sqy_bitSet)
  {
    this.meta = meta;    
    this.keys = keys;
    this.sqy_bitSet = sqy_bitSet;
  }
  
  public int execute()
  throws SQLException
  {
    SSessionJdbc session = SSessionJdbc.getThreadLocalSession();
    SRecordInstance rec = session.findOrCreate(meta, keys);
    try {
      ReflectionHelpers.callVoid("readFrom", rec, transportObject);
      return 1;
    }
    catch (Exception e) {
      throw new SException.Data(e);
    }    
  }

}
