package org.hmn.jrsd.rt.rows;

import java.io.Serializable;
import java.util.HashMap;

/*
 * 
 * Cree par Harry Karadimas a 5 fvr. 2007
 */
/**
 * 
 * @author karadimas
 */
public class JdbcResultColumn
implements Serializable
{
  private static final long serialVersionUID = 8382036566322692782L;
  
  int columnIndex;
  String columnLabel;
  int columnType;
  String typeName;
  JdbcResultColumns parent;
  HashMap<?,?> st = null;
  
  public JdbcResultColumn(
      JdbcResultColumns parent,
      int index, String label, int type, String typeName)
  {
    this.parent = parent;
    this.columnIndex = index;
    this.columnLabel = label;
    this.columnType = type;
    this.typeName = typeName;
  }
  
  public int getIndex() {
    return columnIndex;
  }
  public void setIndex(int columnIndex) {
    this.columnIndex = columnIndex;
  }
  public String getLabel() {
    return columnLabel;
  }
  public void setLabel(String lbl) {
    this.columnLabel = lbl;
  }
  public JdbcResultColumns getColumns() {
    return parent;
  }
  
  /**
   * SQL type number
   * @see java.sql.Types
   * @return
   */
  public int getType()
  {
    return columnType;
  }
  public void setType(int columnType)
  {
    this.columnType = columnType;
  }
  public String getTypeName() {
    return typeName;
  }
  public void setTypeName(String typeName) {
    this.typeName = typeName;
  }

  /**
   * Additional values for use with Stringtemplate or other template engines
   * that accept only POJOs
   * @return
   */
  public HashMap<?,?> getSt() {
    return st;
  }

  public void setSt(HashMap<?,?> st) {
    this.st = st;
  }
}
