package org.hmn.jrsd.rt.rows;

import java.io.Serializable;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;


/*
 * 
 * Cree par Harry Karadimas a 5 fvr. 2007
 */
/**
 * 
 * @author karadimas
 */
public class JdbcResultColumns
implements Serializable
{
  private static final long serialVersionUID = 7499430968664798605L;
  
  int columnCount;
  ArrayList<JdbcResultColumn> colList = new ArrayList<JdbcResultColumn>();
  
  public JdbcResultColumns(ResultSet rs)
  throws SQLException
  {
    ResultSetMetaData md = rs.getMetaData();
    columnCount = md.getColumnCount();
    for (int i = 1; i <= columnCount; i++) {
      String label = md.getColumnLabel(i);
      int type = md.getColumnType(i);
      String typeName = md.getColumnTypeName(i);
      JdbcResultColumn col =
        new JdbcResultColumn(this, i, label, type, typeName);
      colList.add(col);
    }
  }
  
  public JdbcResultColumn getColumn(int index) {
    return (JdbcResultColumn) colList.get(index);
  }
  
  public int getColumnCount() {
    return columnCount;
  }
    
  public List<JdbcResultColumn> getList() {
    return colList;
  }
    
}
