package simpleorm.dataset;

import java.io.BufferedReader;
import java.io.Reader;
import java.io.StringWriter;
import java.sql.ResultSet;
import java.sql.Types;

public class SFieldClob2
extends SFieldScalar
{
  private static final long serialVersionUID = 1L;

  public SFieldClob2(SRecordMeta<?> record, String fieldName, SFieldFlags... pvals )
  {
    super(record, fieldName, pvals);
  }

  @Override
  public String defaultSqlDataType() { return "CLOB"; }

  @Override
  boolean isFKeyCompatible(SFieldScalar field) {
    if (!(field instanceof SFieldClob2)) return false;
    return true;
  }

  @Override
  public int javaSqlType() { return Types.CLOB; }

  @Override
  protected Object convertToDataSetFieldType(Object raw)
  throws Exception
  {
    return raw;
  }

  @Override
  public Object queryFieldValue(ResultSet rs, int sqlIndex)
  throws Exception
  {
    Reader rdr = rs.getCharacterStream(sqlIndex);
    BufferedReader brdr = new BufferedReader(rdr);
    StringWriter sw = new StringWriter();
    int c;
    while ((c = brdr.read()) >= 0) sw.write(c); 
    rdr.close();
    return sw.toString();
  }

}
